/*
* $Id: psp2chMenu.c 148 2008-08-27 06:31:27Z bird_may_nike $
*
* 2010-05-31 STEAR BGMt@C[֘AC
*/

#include "FreezeViewer.h"
#include "psp2ch.h"
#include <psputility.h>
#include <psppower.h>
#include <psprtc.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <malloc.h>

#include "psp2chIni.h"
#include "fileList.h"
#include "psp2chImageView.h"
#include "psp2chAudio.h"
#include "charConv.h"
#include "fvDraw.h"
#include "psp2chError.h"
#include "pspdialogs.h"
#include "intraFont.h"
#include "message.h"

//----- 萔ݒ -----

#define LISTPITCH		(24)									// Xg̍s
#define LISTCOUNT		(12)									// Xg̍s

//----- OQ -----

extern S_2CH s2ch; // psp2ch.c
extern char keyWords[128]; //psp2ch.c

//----- \ -----

typedef struct {
	char		path[1024];										// TlCtH_
	DirList		*DList;											// TlC擾t@Cւ̃|C^
} strGetThumb;

//------ O[oϐ -----

static DirList	FileList[4];
static int		gThumbId;										// TlC擾Xbh
static int		gGetDirId[2];									// tH_ꗗ擾Xbh

static volatile int		gGetDirEnd[2],							// tH_W֘AXbh̋~w
						gGetThumbEnd;							// TlCWXbh̋~w

//----- vg^Cv錾 -----

static int psp2chMenuFileCtrl(char* path, char* name, int status);

int	SMEMOfile(char *path);										// PSP
int unzipToDir(const char *zippath, const char *destpath, const char *pass,char *info);	// miniunz.c
int mainRAR(int argc, char *argv[]);													// rar.cpp


/****************
j[EBhE`
****************/
static void psp2chDrawMenu(char** menuList, int x, int y, int width, int height)
{
    int i, start, lineEnd;
/*
    lineEnd = height / LINE_PITCH;
    start = menu.start;
    if (start + lineEnd > menu.count)
    {
        start = menu.count - lineEnd;
    }
    if (start < 0)
    {
        start = 0;
    }
    pgFillvram(0, 0, 0, BUF_WIDTH, BUF_HEIGHT, 2);
    pgFillvram(s2ch.menuWinColor.bg, x, y, width, height, 2);
    for (i = start; i < start + lineEnd; i++)
    {
        if (i >= menu.count)
        {
            return;
        }
        if (i == menu.select)
        {
            pgFillvram(s2ch.menuWinColor.s_bg, x, winParam->pgCursorY, width, LINE_PITCH, 2);
            pgPrint(menuList[i], s2ch.menuWinColor.s_text, s2ch.menuWinColor.s_bg, x + width);
        }
        else
        {
            pgPrint(menuList[i], s2ch.menuWinColor.text, s2ch.menuWinColor.bg, x + width);
        }
    }
*/
}

//==============================================================
// fBNgXg̍폜
//--------------------------------------------------------------

static void deleteDirList(DirList **DListPtr)
{
	DirList	*DList;
	int		i;

	DList = *DListPtr;
	if (DList->file == NULL) return;

	for (i = 0; i < DList->count; i++)
	{
		free(DList->file[i].name2);
		free(DList->file[i].name);
		DrawImgFree(DList->file[i].thumb);
	}
	free(DList->file);
	DList->file = NULL;
	DList->count = 0;
	DList->pos = 0;
}

//==============================================================
// Xe[^X\
//--------------------------------------------------------------
// \BGMt@C\sB
// GU̍ݒsAs邱ƁB
//--------------------------------------------------------------

void statusDraw(DirList *DList, int reset)
{
	struct mallinfo	minfo;
	char	str[256], buf[32];
	int		battery, w;
	pspTime	time;
	static float	x_scroll1;
	static char		bgmFileBak[FILE_PATH], bgmFileUtf8[FILE_PATH];

	if (sceRtcGetCurrentClockLocalTime(&time) < 0) {			// 
		strcpy( str, "--/-- --:--" );
	} else {
		sprintf( str, "%d/%d %d:%02d", time.month, time.day, time.hour, time.minutes );
	}
	battery = scePowerGetBatteryLifePercent();					// obe[
	if (battery < 0) {
		strcat( str, "  ---%" );
	} else {
		sprintf( buf, "  %d%%", battery );
		strcat( str, buf );
	}
	intraFontSetStyle( gJpn0, 0.7f, 0, 0, 0 );
	w = intraFontMeasureText( gJpn0, str );
	if_print( 475-w, 16, str, 0.7f, 0xFFFFFF, 0x404040, 0.7f );

	if_clipText( str, DList->path, 350, 0.7f );
	if_print( 5, 16, str, 0.7f, 0xFFFFFF, 0x404040, 0.7f );

//	minfo = mallinfo();
//	sprintf( str, "%dKB", minfo.uordblks/1024 );
//	if_print( 280, 16, str, 0.7f, 0xFFFFFF, 0x404040, 0.7f );

	if (reset!=1 && strlen(s2ch.bgmFile)) {						// BGMt@C
		if (strcmp(bgmFileBak, s2ch.bgmFile)!=0) {				// BGMς
			strcpy( bgmFileBak, s2ch.bgmFile );
			psp2chSjis2UTF8( bgmFileUtf8, bgmFileBak );
			x_scroll1 = 300;
		}
		intraFontSetStyle( gJpn0, 0.7f, 0xC0FFFFFF, 0xC0404040, INTRAFONT_SCROLL_LEFT );
		x_scroll1 = intraFontPrintColumn( gJpn0, x_scroll1, 32, 170, bgmFileUtf8 );
	} else {													// BGM~܂
		bgmFileBak[0] = '\0';
		x_scroll1 = 300;
	}
}

//==============================================================
// Xg\pTlC̍
//--------------------------------------------------------------

void thumbDraw(DirList *DList, int x, int y, int alpha, int start, int count, int max)
{
	int		i, x2, y2;
	float	alp, range;

	if (DList->file == NULL) return;

	for (i = start; i < start + count; i++){
		if (i >= 0) {
			if (i >= max){										// XgI[zȂ
				break;
			}
			if (i == DList->pos){								// J[\ʒu
				alp = alpha / 100.0f;
				range = 64.0f / THUMBXSIZE;
				if (DList->file[i].type == 1) {					// fBNgp
					x2 = x      - (gIconImg[0]->wx * range / 2);
					y2 = y + 18 - (gIconImg[0]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[0], alp, range );
				} else {										// t@Cp
					if (DList->file[i].thumb) {					// TlC摜Ȃ
						x2 = x      - (DList->file[i].thumb->wx * range / 2);
						y2 = y + 18 - (DList->file[i].thumb->wy * range / 2);
						DrawPicAlpha( x2, y2, DList->file[i].thumb, alp, range );
					} else {									// TlC摜Ȃ
						x2 = x      - (gIconImg[1]->wx * range / 2);
						y2 = y + 18 - (gIconImg[1]->wy * range / 2);
						DrawPicAlpha( x2, y2, gIconImg[1], alp, range );
					}
				}
			} else {											// J[\ȊÖʒu
				alp = 0.7f * y / (y<=19 ? 19 : y) * alpha / 100;
				range = 32.0f / THUMBXSIZE;
				if (DList->file[i].type == 1) {					// fBNgp
					x2 = x     - (gIconImg[0]->wx * range / 2);
					y2 = y + 7 - (gIconImg[0]->wy * range / 2);
					DrawPicAlpha( x2, y2, gIconImg[0], alp, range );
				} else {										// t@Cp
					if (DList->file[i].thumb) {					// TlC摜Ȃ
						x2 = x     - (DList->file[i].thumb->wx * range / 2);
						y2 = y + 7 - (DList->file[i].thumb->wy * range / 2);
						DrawPicAlpha( x2, y2, DList->file[i].thumb, alp, range );
					} else {									// TlC摜Ȃ
						x2 = x     - (gIconImg[1]->wx * range / 2);
						y2 = y + 7 - (gIconImg[1]->wy * range / 2);
						DrawPicAlpha( x2, y2, gIconImg[1], alp, range );
					}
				}
			}
		}
		if (i == DList->pos) y += LISTPITCH;
		y += LISTPITCH;
	}
}

//==============================================================
// t@CXg\
//--------------------------------------------------------------
// alpha : Ŝ̓ߌv
// reset : w 0:ʏ\ 1:Sď 2:BGM\͂̂܂
//--------------------------------------------------------------
// ʑŜXVăt@CXgꗗ\܂B
//--------------------------------------------------------------

void ListDrawSub(DirList *DList, DirList *DList2, int x, int y,int alpha, int alpha2, int reset)
{
	static float	y2 = -1;
	static unsigned char	blink = 0;
	static int				blFlg = 1;
	float			sy, alp, range;
	char			buf[256], buf2[32];
	int				a, i, start, count, max;

	blitImageToScreen(0, 0, 480, 272, gScrBuf1, 0, 0);			// wiI[o[Ch
	max = DList->count;

	guStart();
	sceGuClear(GU_DEPTH_BUFFER_BIT);
	statusDraw( DList, reset);

	thumbDraw( DList2, x-36-64, y-4*LISTPITCH, 50, DList2->pos-4, LISTCOUNT, DList2->count );

	if (max == 0) {												// Xgꍇ
		if_print( x, y+12, "No Data", 0.8f, 0xC0C0FF, 0x101010, alpha/100 );
		sceGuFinish();
		return;
	}

	//----- Y\ʒu␳ -----

	count = LISTCOUNT;
	sy = DList->pos * LISTPITCH;								// _ł̖ڕWzW
	if (reset) {
		y2 = sy;
		blink = 0;
		blFlg = 1;
	} else {
		a = abs(sy - y2);
		y2 += (sy - y2) / (a<24 ? 8 : 5);
		if (a==0) {												// ړ~
			y2 = sy;
		} else {												// ړ
			count++;											// ړ͕\鍀ڐP₷
		}
	}
	start = (y2 / LISTPITCH) - 4;								// 4:J[\ʒu
	if (start<0) {
		count -= start;
	}
	y -= y2 - start * LISTPITCH;

	//----- Xg\ -----

	thumbDraw( DList, x-36, y, alpha2, start, count, max );		// TlC̕\

	if (blFlg > 0) {											// e̓_
		blink += 6;
		if (blink > 0xF8) blFlg = -blFlg;
	} else {
		blink -= 6;
		if (blink < 0x10) blFlg = -blFlg;
	}
	for (i = start; i < start + count; i++){
		if (i >= 0) {
			if (i >= max){										// XgI[zȂ
				break;
			}
			if (DList->file[i].name != NULL) {
				if (i == DList->pos){							// J[\ʒu
					if_clipText( buf, DList->file[i].name, 335, 0.8f );
					alp = alpha / 100.0f;
					range = 64.0f / THUMBXSIZE;
					if (DList->file[i].type == 1) {				// fBNgp
						if_print( x, y+12, buf, 0.8f, 0x00FFFF, blink/2 + ((blink/2)<<8) + (blink<<16), alp );
					} else {									// t@Cp
						if_print( x, y+12, buf, 0.8f, 0xFFFFFF, blink/2 + ((blink/2)<<8) + (blink<<16), alp );
					}
					if (alpha==100) {
						drawLineScreen( x, y+17, x+335, y+17, 0xFFFFFF );
					}
					sprintf( buf, "%04d/%02d/%02d  %d:%02d", DList->file[i].mtime.year, DList->file[i].mtime.month, DList->file[i].mtime.day
					                                       , DList->file[i].mtime.hour, DList->file[i].mtime.minute );
					if (!DList->file[i].type) {					// t@CTCY
						if (DList->file[i].size < 1024) {
							sprintf( buf2, "  %dB", (int)DList->file[i].size );
						} else if (DList->file[i].size < 1024 * 1024) {
							sprintf( buf2, "  %dKB", (int)DList->file[i].size / 1024 );
						} else {
							sprintf( buf2, "  %dMB", (int)DList->file[i].size / (1024 * 1024) );
						}
						strcat( buf, buf2 );
					}
					if (DList->file[i].xSize != 0) {			// 摜TCY
						sprintf( buf2, "  %dx%d", DList->file[i].xSize, DList->file[i].ySize );
						strcat( buf, buf2 );
					}
					if_print( x, y+30, buf, 0.6f, 0xFFFFFF, 0x101010, alpha/100 );
				} else {										// J[\ȊÖʒu
					alp = 0.7f * y / (y<=19 ? 19 : y) * alpha / 100;
					if_clipText( buf, DList->file[i].name, 335, 0.8f );
					range = 32.0f / THUMBXSIZE;
					if (DList->file[i].type == 1) {				// fBNgp
						if_print( x, y+12, buf, 0.8f, 0x00FFFF, 0x101010, alp );
					} else {									// t@Cp
						if_print( x, y+12, buf, 0.8f, 0xFFFFFF, 0x101010, alp );
					}
				}
			}
		}
		if (i == DList->pos) y += LISTPITCH;
		y += LISTPITCH;
	}
	sceGuFinish();
}

//==============================================================
// ZIPt@C
//--------------------------------------------------------------
// ߂lF1     WJĂȂidestpathtH_͐ĂȂj
//         0     I
//         0ȉ G[idestpathtH_ɈꕔWJĂj
//--------------------------------------------------------------
// fileŎw肳ꂽzipt@CdestpathtH_֓WJB
// WJύXꍇ͕ύX̃pXdestpathɕԂB
//--------------------------------------------------------------

static int Unzip(char *file, char *destpath)
{
	char	*p,msg[256];
	int		ret;

	if (psp2chInputDialog("WJtH_͂Ă", "WJtH_", destpath)) return 1;
	if (strlen(keyWords)==0) return 1;
	strcpy(destpath, keyWords);
	p = strrchr(destpath, '.');
	if (p) *p = '\0';											// gq͍폜
	if (psp2chInputDialog("Kvȏꍇ̓pX[h͂Ă", "pX[h", NULL)) return 1;

	strcpy(msg, file);
	strcat(msg, "WJ");

	ret = unzipToDir(file, destpath, keyWords, msg);			// A[JCuWJ

	if (ret){													// G[
		char	buf[256];
		sprintf(buf, "%s̓WJŖ肪N܂\n\n", file);
		strcat(buf, msg);
		psp2chErrorDialog(0, buf);
	}
	return ret;
}

//==============================================================
// RARt@C
//--------------------------------------------------------------
// ߂lF1     WJĂȂidestpathtH_͐ĂȂj
//         0     I
//         0ȉ G[idestpathtH_ɈꕔWJĂj
//--------------------------------------------------------------
// fileŎw肳ꂽrart@CdestpathtH_֓WJB
// WJύXꍇ͕ύX̃pXdestpathɕԂB
//--------------------------------------------------------------

static int UnRAR(char *file, char *destpath)
{
	char	*p, msg[256], extDir[256];
	char	**argv, **currentString;
	int		i, ret, argc, count;
	unsigned short	ucs[256];

	if (psp2chInputDialog("WJtH_͂Ă", "WJtH_", destpath)) return 1;
	if (strlen(keyWords)==0) return 1;
	strcpy(destpath, keyWords);
	p = strrchr(destpath, '.');
	if (p) *p = '\0';											// gq͍폜
	if (psp2chInputDialog("Kvȏꍇ̓pX[h͂Ă", "pX[h", NULL)) return 1;

	if (s2ch.cfg.hbl){											// HBLł̓t@C̃VtgJISUTF8ϊs
		psp2chSJIS2UCS(ucs, destpath, 256);
		psp2chUCS2UTF8(extDir, ucs);
	} else {
		strcpy(extDir, destpath);
	}
	argv = calloc( 8, sizeof(char *) );
	currentString = argv;
	if (strlen(keyWords)==0){									// pX[hw肳ĂȂ
		argc = 5;
		count = argc+1;
		for ( i=0; i<count; i++ ){
			if (i==0) asprintf( currentString, "unrar");
			if (i==1) asprintf( currentString, "x");
			if (i==2) asprintf( currentString, "%s", file);
			if (i==3) asprintf( currentString, "%s", extDir);
			if (i==4) asprintf( currentString, "-y");
			if (i> 4) asprintf( currentString, " ");
			currentString++;
		}

	}else{														// pX[hw肳ꂽ
		argc = 6;
		count = argc+1;
		for ( i=0; i<count; i++ ){
			if (i==0) asprintf( currentString, "unrar");
			if (i==1) asprintf( currentString, "x");
			if (i==2) asprintf( currentString, "%s", file);
			if (i==3) asprintf( currentString, "%s", extDir);
			if (i==4) asprintf( currentString, "-y");
			if (i==5) asprintf( currentString, "-p%s", keyWords);
			if (i> 5) asprintf( currentString, " ");
			currentString++;
		}
	}

	if (createDir(extDir)<0){
		psp2chErrorDialog(0, "%s\ntH_̍쐬Ɏs܂", extDir);
		return 1;
	}
	ret = mainRAR(argc,argv);									// A[JCuWJ
	if (ret){													// G[
		char	buf[256];
		sprintf(buf, "%s̓WJŖ肪N܂\n\n", file);
//		strcat(buf, msg);
		psp2chErrorDialog(0, buf);
	}

	currentString = argv;
	for ( i = 0; i < count; i++ ){
		free( *currentString );
		currentString++;
	}
	free(argv);
	return ret;
}

//==============================================================
// t@C̊gq̔
//--------------------------------------------------------------
// ߂l : 0 `9  摜t@C
//          10`19 t@C
//          20`29 eLXgt@C
//          90     A[JCut@C
//          99     gqȂ
//          100    ̑̃t@C
//--------------------------------------------------------------

static int checkExt(char *path)
{
	char	*p;

	p = strrchr( path, '.' );
	if (p == NULL) return 99;

	if (stricmp(p, ".jpg") == 0 || stricmp(p, ".jpeg") == 0) {
		return 0;
	} else if (stricmp(p, ".png") == 0) {
		return 1;
	} else if (stricmp(p, ".gif") == 0) {
		return 2;
	} else if (stricmp(p, ".bmp") == 0) {
		return 3;
	} else if (stricmp(p, ".mp3") == 0) {
		return 10;
	} else if (stricmp(p, ".txt") == 0 || stricmp(p, ".ini") == 0 || stricmp(p, ".cfg") == 0) {
		return 20;
	} else if (stricmp(p, ".zip") == 0 || stricmp(p, ".rar") == 0) {
		return 90;
	}
	return 100;
}

//==============================================================
// gqɑΉ
//--------------------------------------------------------------
// 摜t@C̏ꍇ͑đỎ摜t@C\鎖B
//--------------------------------------------------------------

static void doFile(char *path, char *file, DirList *DList)
{
	static int	picMenu = 1;
	FileData	*FData;
	char	*p, name[FILE_PATH];
	int		i, ret, type, next, chKey, thumbFlag;

	thumbFlag = -1;
	while (!gExitRequest){										// 摜p[v
		strcpy( name, DList->file[DList->pos].name2 );
		type = checkExt(name);									// gq
		ret = 0;
		FData = &DList->file[DList->pos];
		switch (type) {
		case 0:													// jpg
			ret = psp2chMenuImageView(file, FData, &picMenu, &thumbFlag, 0);
			break;
		case 1:													// png
			ret = psp2chMenuImageView(file, FData, &picMenu, &thumbFlag, 1);
			break;
		case 2:													// gif
			ret = psp2chMenuImageView(file, FData, &picMenu, &thumbFlag, 2);
			break;
		case 3:													// bmp
			ret = psp2chMenuImageView(file, FData, &picMenu, &thumbFlag, 3);
			break;
		case 10:												// mp3
			psp2chAudioPlay(path, name);
			break;
		case 20:												// eLXg
			SMEMOfile( file );									// wt@CPSPŊJ
			break;
		}

		if (type<10 && (s2ch.pad.Buttons & (PSP_CTRL_RTRIGGER | PSP_CTRL_LTRIGGER)) ){	// 摜
			if (s2ch.cfg.keySwap){								// 摜L[̓ւ
				chKey = PSP_CTRL_LTRIGGER;
			} else {
				chKey = PSP_CTRL_RTRIGGER;
			}
			if (s2ch.pad.Buttons & chKey){						// ̉摜
				next = -1;
				DList->pos++;
				if (DList->pos>=DList->count) DList->pos = 0;
				while (next==-1){								// ̉摜t@CT
					for (i=DList->pos; i<DList->count; i++){
						if (checkExt(DList->file[i].name) < 10) {
							next = i;
							break;
						}
					}
					if (next==-1) DList->pos = 0;				// 摜Ȃΐ擪ɖ߂Ă蒼
				}
			} else {											// Ỏ摜
				next = -1;
				DList->pos--;
				if (DList->pos<0) DList->pos = DList->count -1;
				while (next==-1){								// Ỏ摜t@CT
					for (i=DList->pos; i>=0; i--){
						if (checkExt(DList->file[i].name)<10) {
							next = i;
							break;
						}
					}
					if (next==-1) {								// 摜Ȃ΍Ōɖ߂Ă蒼
						DList->pos = DList->count - 1;
					}
				}
			}
			DList->pos = next;									// ɕ\摜
			strcpy( file, path );
			strcat( file, "/" );
			strcat( file, DList->file[DList->pos].name2 );

		} else {
			break;												// 摜Ƃ͊֌WȂ̂Ń[vI
		}
	}

	if (type<10 && ret==0) {									// 摜\Ăꍇ͔wiޔ
		BoxFillImage( gScrMask, 0, 0, 480, 16, 0xC0000000 | s2ch.BakCor );
		flipScreen(0);
		guStart();
		sceGuClear(GU_DEPTH_BUFFER_BIT);
		for (i=0; i<272/16; i++) {								// ʂÂ
			DrawPicAlpha( 0, i*16, gScrMask, 50, 1.0f );
		}
		sceGuFinish();
		sceGuSync(GU_SYNC_FINISH, GU_SYNC_WHAT_DONE);
		flipScreen(0);
		blitScreenToImage(0, 0, 480, 272, gScrBuf1, 0, 0);
	}
}

//==============================================================
// TlC擾Xbh
//--------------------------------------------------------------
//  getDirThread() N܂B
// J[\̈ړɍ킹ăTlCtH_̃TlCǂݍ݂܂B
// xNƒ~܂ŋNςȂB
// DList.pos̑OTHUMBMAX̃TlCǂݍ݁AȊO͍폜܂B
// DList.posɋ߂ʒuǂݍł܂B
// gGetThumbEnd-1wƏ𒆒fďI܂B
//--------------------------------------------------------------

static int getThumbnailThread(SceSize args, void *argp)
{
	unsigned short	*buf;
	SceUID		fd;
	SceIoStat	st;
	DrawImg		*thumb;
	volatile strGetThumb	*th;
	FileData	*FData;
	int		i, limit, pos, pos2, posBak, count, sg, ab;
	char	path[1024];

	th = *(strGetThumb**)argp;
	FData = th->DList->file;									// t@Cz
	posBak = -1;

	while (!gGetThumbEnd) {
		count = th->DList->count;								// t@Č
		if (th->DList->pos == posBak || count == 0) {			// J[\ʒuωĂȂȂ
			sceDisplayWaitVblankStart();
			continue;
		}
		posBak = th->DList->pos;
		pos = th->DList->pos;
		for (i=0; i<count; i++) {								// ͈͊OTlC폜
			if (abs(pos - i)>THUMBMAX/2) {
				FData[i].xSize = 0;
				DrawImgFree(FData[i].thumb);
				FData[i].thumb = NULL;
			}
		}
		sg = -1;												// 
		ab = 0;													// Βl
		for (i=0; i<THUMBMAX; i++) {							// TlCt@C̓ǂݍ
			if (pos != th->DList->pos) break;					// J[\ʒuɕω璆f
			if (gGetThumbEnd) break;
			pos2 = pos + sg * ab;								// TlC擾Ώ
			if (pos2>=0 && pos2<count && FData[pos2].type==0 && FData[pos2].xSize==0) {
				strcpy( path, th->path );
				strcat( path, "/" );
				strcat( path, FData[pos2].name2 );
				strcat( path, ".dat" );
				if (sceIoGetstat( path, &st ) >= 0) {			// TlCt@CȂRRŎsnY
					fd = sceIoOpen( path, PSP_O_RDONLY, FILE_PARMISSION );
					if (fd >= 0) {
						limit = st.st_size;
						if (limit >= 32 + THUMBXSIZE * THUMBYSIZE * sizeof(Color) + 32) {
							limit = 32 + THUMBXSIZE * THUMBYSIZE * sizeof(Color) + 32 - 1;
						}
						buf = (unsigned short*)malloc(limit);
						if (buf == NULL) break;
						if (sceIoRead(fd, buf, limit) == limit) {
							if (buf[0]==(THUMBID | 0x0100) &&
							        buf[1]<=THUMBXSIZE && buf[2]<=THUMBYSIZE) {
								thumb = DrawImgCreate( buf[1], buf[2] );	// TlC摜
								if (thumb) {
									FData[pos2].thumb = thumb;
									FData[pos2].thumbTime.year   = buf[3];
									FData[pos2].thumbTime.month  = buf[4];
									FData[pos2].thumbTime.day    = buf[5];
									FData[pos2].thumbTime.hour   = buf[6];
									FData[pos2].thumbTime.minute = buf[7];
									FData[pos2].thumbTime.second = buf[8];
									FData[pos2].xSize            = buf[9];
									FData[pos2].ySize            = buf[10];
									memcpy( (char*)FData[pos2].thumb->data, (char*)&buf[16], limit - 32 );
								}
							}
						}
						free(buf);
						sceIoClose(fd);
					}
				}
			}
			if (sg < 0) ab++;									// }CiXȂΒl+1
			sg = -sg;											// 𔽓]
		}
	}

	sceKernelExitThread(0);
	return 0;
}

//==============================================================
// fBNg擾Xbh
//--------------------------------------------------------------
//  GetDir() N܂B
// gGetDirEnd-1wƏ𒆒fďI܂B
// t@Cꗗ擾oTlC擾XbhN܂B
//--------------------------------------------------------------

static int getDirThread(SceSize args, void *argp)
{
	static strGetThumb	thDat, *th;
	SceUID		fd;
	SceIoDirent	dir;
	DirList		*DList;
	FileData	*FData, FDataBuf;
	int		i, j, pos, count;
	char	*p, *buf, utf8[1536];

	//----- ݒ -----

	DList = *(DirList**)argp;

	//----- Gg̃JEg -----

	if ((fd = sceIoDopen(DList->path2)) < 0) {					// tH_ɃANZXoȂ
		DList->complete = -1;
		sceKernelExitThread(0);
		return 0;
	}
	memset(&dir, 0, sizeof(dir));								// ȂreadɎs
	count = 0;
	while (sceIoDread(fd, &dir) > 0) {							// tH_Gg̃JEg
		if (gGetDirEnd[DList->getDirMode]) {					// f
			break;
		}
		if (dir.d_name[0] == '.') {
			if (dir.d_name[1] == '\0' || (dir.d_name[1] == '.' && dir.d_name[2] == '\0')) {
				continue;
			}
		}
		count++;
	}
	sceIoDclose(fd);
	FData = (FileData*)malloc(sizeof(FileData) * count);		// GgXgpӂĂ
	DList->file = FData;
	if (FData == NULL) {
		DList->complete = -1;
		sceKernelExitThread(0);
		return 0;
	}

	//----- Ggȅ -----

	for (i=0; i<count; i++) {
		FData[i].name = NULL;
		FData[i].name2 = NULL;
		FData[i].thumb = NULL;
		FData[i].xSize = 0;
	}
	DList->count = count;

	//----- Gge擾 -----

	if ((fd = sceIoDopen(DList->path2)) < 0) {					// ł͎sȂnY
		free(FData);
		DList->complete = -1;
		sceKernelExitThread(0);
		return 0;
	}
	i = 0;
	memset(&dir, 0, sizeof(dir));
	while (sceIoDread(fd, &dir) > 0) {							// Gge擾
		if (gGetDirEnd[DList->getDirMode]) {					// f
			count = i;
			break;
		}
		if (dir.d_name[0] == '.') {
			if (dir.d_name[1] == '\0' || (dir.d_name[1] == '.' && dir.d_name[2] == '\0')) {
				continue;
			}
		}
		buf = (char*)malloc(sizeof(char) * (strlen(dir.d_name) + 1));
		if (buf==NULL) {										// ȂI
			count = i;											// 擾ł܂ł͗L
			break;
		}
		FData[i].name2 = buf;
		strcpy( FData[i].name2, dir.d_name );					// t@C(VtgJIS)
		if (s2ch.cfg.hbl) {
			strcpy( utf8, dir.d_name );
		} else {
			psp2chSjis2UTF8( utf8, dir.d_name );
		}
		buf = (char*)malloc(sizeof(char) * (strlen(utf8) + 1));
		if (buf==NULL) {										// ȂI
			count = i;											// 擾ł܂ł͗L
			break;
		}
		FData[i].name = buf;
		if (dir.d_stat.st_attr & FIO_SO_IFDIR) {				// fBNgHt@CH
			FData[i].type = 1;									// fBNg
		} else {
			FData[i].type = 0;									// t@C
		}
		strcpy( FData[i].name, utf8 );							// t@C(UTF8)
		FData[i].size = dir.d_stat.st_size;						// t@CTCY
		FData[i].mtime = dir.d_stat.st_mtime;					// XV
		FData[i].thumb = NULL;
		FData[i].xSize = 0;										// 摜XTCY (0:擾ĂȂ)
		FData[i].ySize = 0;										// 摜YTCY
		i++;
		
		if (i >= count) break;
	}
	sceIoDclose(fd);
	DList->count = count;

	//----- \[g -----

	if (s2ch.cfg.fileSort && !gGetDirEnd[DList->getDirMode]) {	// t@Cz\[g
		for (i=0; i<count-1 ;i++) {
			for (j=i+1; j<count ;j++) {
				if ((strcmp(FData[i].name,FData[j].name)>0 && FData[i].type==FData[j].type)
				        || (!FData[i].type && FData[j].type)) {
					FDataBuf = FData[i];
					FData[i] = FData[j];
					FData[j] = FDataBuf;
				}
			}
		}
	}

	//----- TlC擾Xbh̋N -----

	DList->complete = 1;										// Xg擾

	if (!gGetDirEnd[DList->getDirMode] && DList->getDirMode==1) {
		p = strchr( DList->path2, ':' );
		if (p) {												// hCu^[Ȃ
			pos = p - DList->path2 + 1;
			strncpy( thDat.path, DList->path2, pos );
			thDat.path[pos] = '/';
			thDat.path[pos+1] = '\0';
			strcat( thDat.path, THUMBFOLDER );					// TlCtH_
			strcat( thDat.path, &DList->path2[pos] );			// TlCۑĂnỸtH_
			thDat.DList = DList;
			th = &thDat;
			sceKernelStartThread( gThumbId, sizeof(strGetThumb**), (void*)&th );
		}
	}

	sceKernelExitThread(0);
	return 0;
}

//==============================================================
// fBNg擾
//--------------------------------------------------------------
// file     :擾tH_iVtgJISj
// DListPtr :Xg\
// mode     :TlC擾邩 0:NO 1:Yes
// ߂l   : 0:I -1:G[
//--------------------------------------------------------------
// w肳ꂽpX̃t@Cꗗ擾XbhN܂B
// w肳ꂽpXɃANZXoȂꍇ̓[gɃANZX݂܂A
// [gɂANZXoȂꍇ̓G[Ԃ܂B
//
// intraFontŕ\s֌WŁAVtgJISR[hx[XƃR[hϊɖł
// ȂԂ|Ă܂UTF8R[hx[XɕύXB
//
// TlCC[Wۑʒu̓[g THUMBFOLDER tH_
// ms0:/FVthumb/PICTURE/hoge.jpg.dat
//
// fBNg̎擾̓}`Xbhōs邽߁AXg̎擾ɂ͎Ԃ|܂B
// Xg擾o DListPtr->complete 0ȊO̒lɂȂ܂B
//--------------------------------------------------------------

static int GetDir(char* file, DirList **DListPtr, int mode)
{
	static strGetThumb	thDat, *th;
	SceUID	fd;
	DirList	*DList;
	char	*p, path[1024];
	int		pos;

	//----- ֘AXbh̋~ -----

	if (sceKernelGetThreadExitStatus(gGetDirId[mode]) != 0) {
		gGetDirEnd[mode] = -1;									// fBNgꗗ擾̒~
		sceKernelWaitThreadEnd(gGetDirId[mode], NULL);
	}

	if (mode) {
		gGetThumbEnd = -1;										// TlCꗗ擾̒~
		sceKernelWaitThreadEnd(gThumbId, NULL);
	}

	//----- ݒ -----

	DList = *DListPtr;

	strcpy( path, file );
	if (path[strlen(path)-1]=='\\') strcat(path,"\\");
	if ((fd = sceIoDopen(path)) < 0) {							// path̍Ō'\'Ƃȓc?
		psp2chNormalError( DIR_OPEN_ERR, file );
		p = strchr( path, ':' );
		if (p) {
			*(p+1) = '\0';
		} else {												// 肦ȂnY
			strcpy( path, "ms0:" );
		}
		if ((fd = sceIoDopen(path)) < 0) {
			DList->complete = -1;
			return -1;											// [gɃANZXoȂȂI
		}
		strcpy( file, path );
	}
	sceIoDclose(fd);

	//----- fBNgGg擾XbhN -----

	psp2chSjis2UTF8( DList->path, path );
	strcpy( DList->path2, path );
	DList->complete = 0;
	DList->count = 0;
	DList->pos = 0;
	DList->file = NULL;
	DList->getDirMode = mode;
	gGetDirEnd[mode] = 0;
	gGetThumbEnd = 0;
	sceKernelStartThread( gGetDirId[mode], sizeof(DirList**), (void*)&DList );

	return 0;
}

//==============================================================
// Xg\
//--------------------------------------------------------------
// DList[4] : Xg [0]:J[\ʒu [1]:TlĈ [2]-[3]:ړp
// mode     : Jڎw 0:wȂ 1:\Zbg 2:̃fBNgֈړ
//                     3:ÕfBNgֈړ
//--------------------------------------------------------------
// DList[1]͈̃fBNgB
//--------------------------------------------------------------

void ListDraw(DirList *DList[], int mode)
{
	static int		smode, count;
	static float	x2;
	int			i, startX = 125, startY = 120, reset;
	float		sy;

	//----- ԑJ -----

	reset = 0;
	switch (mode) {
	case 1:														// \Zbg
		smode = 0;
		count = 0;
		ListDrawSub( DList[0], DList[1], startX, startY, 100, 100, 1 );
		return;
		break;
	case 2:														// ̃fBNgֈړ
		reset = (smode==0 ? 0 : 2);								// ړɊ荞܂ꂽ
		smode = 2;
		count = 0;
		x2 = 0;
		break;
	case 3:														// ÕfBNgֈړ
		reset = (smode==0 ? 0 : 2);								// ړɊ荞܂ꂽ
		smode = 3;
		count = 0;
		x2 = 0;
		break;
	}

	//----- eԂł̍揈 -----

	switch (smode) {
	case 0:
		ListDrawSub( DList[0], DList[1], startX, startY, 100, 100, 0 );
		break;

	case 2:														// fBNgړ(̃fBNg)
		x2 += (64 - x2) / 4;
		if (count < 6) {
			ListDrawSub( DList[1], DList[2], startX-x2, startY, (5-count)*20, 50+(5-count)*10, reset );
			count++;
		} else if (count < 10) {
			ListDrawSub( DList[0], DList[1], startX+64-x2, startY, (count-5)*30, (count-5)*30, (count==6 ? 2 : 0) );
			count++;
		} else {
			ListDrawSub( DList[0], DList[1], startX, startY, 100, 100, 0 );
			deleteDirList(&DList[2]);
			smode = 0;
		}
		break;

	case 3:														// fBNgړ(ÕfBNg)
		x2 += (64 - x2) / 4;
		if (count < 6) {
			ListDrawSub( DList[1], DList[2], startX+x2, startY, (5-count)*20, (5-count)*20, reset );
			count++;
		} else if (count == 6) {								// ꗗ̎擾܂őҋ@
			if (DList[0]->complete != 0) {
				char	*p, buf[1024];
				for (i=0; i<DList[0]->count ;i++){				// ܂ŋtH_̏ɃJ[\Zbg
					if (!strcmp(DList[0]->dirName,DList[0]->file[i].name2)) {
						DList[0]->pos = i;
						break;
					}
				}
				count++;
				deleteDirList(&DList[1]);
				deleteDirList(&DList[2]);
				if (DList[3]->file != NULL) {
					FileList[1] = FileList[3];
					DList[3]->file = NULL;
					for (i=0; i<DList[1]->count ;i++){			// tH_ʒuɃJ[\Zbg
						if (!strcmp(DList[1]->dirName,DList[1]->file[i].name2)) {
							DList[1]->pos = i;
							break;
						}
					}
				}
				ListDrawSub( DList[0], DList[1], startX-64+x2, startY, 0, 100, 2 );
			} else {
				ListDrawSub( DList[1], DList[2], startX+x2, startY, 0, 0, 2 );
			}
		} else if (count < 10) {
			ListDrawSub( DList[0], DList[1], startX-64+x2, startY, (count-7)*20, 100, 0 );
			count++;
		} else {
			ListDrawSub( DList[0], DList[1], startX, startY, 100, 100, 0 );
			smode = 0;
		}
		break;
	}
}

//==============================================================
// t@CXgꗗ
//--------------------------------------------------------------

void fileList(char* base)
{
	char				*p, path[1024], file[1024], buf[1024];
	DirList				*DList[4];
	int					i, ret, mode, menu;

	if (base) {
		strcpy(path, base);
	} else {
		strcpy(path, s2ch.cwDir);
	}

	gGetDirId[0] = sceKernelCreateThread( "getDir_thread1", (SceKernelThreadEntry)&getDirThread, 0x30, 0x2000, 0, NULL );
	gGetDirId[1] = sceKernelCreateThread( "getDir_thread2", (SceKernelThreadEntry)&getDirThread, 0x30, 0x2000, 0, NULL );
	gThumbId = sceKernelCreateThread( "getThumbnail_thread", (SceKernelThreadEntry)&getThumbnailThread, 0x30, 0x2000, 0, NULL );

	for (i=0; i<4; i++) {
		DList[i] = &FileList[i];								// ʏgp̃fBNgXg
		DList[i]->file = NULL;
	}
	if (GetDir( path, &DList[0], 1 )) goto endFunc;
	strcpy( buf, path );
	p = strrchr( buf, '/' );
	if (p) {
		strcpy( DList[1]->dirName, p+1 );
		*p = '\0';
		GetDir( buf, &DList[1], 0 );
	}
	while (!DList[0]->complete) {								// ꗗ̎擾܂őҋ@
		sceDisplayWaitVblankStart();
	}
	for (i=0; i<DList[1]->count ;i++){							// tH_ʒuɃJ[\Zbg
		if (!strcmp(DList[1]->dirName,DList[1]->file[i].name2)) {
			DList[1]->pos = i;
			break;
		}
	}
	strcpy(file, path);

	DList[0]->pos = 0;
	menu = 0;													// 0:Xg\ 1:j[\

	ListDraw( DList, 1 );
	while (!gExitRequest)
	{
		mode = 0;
		if(sceCtrlPeekBufferPositive(&s2ch.pad, 1))
		{
			if (menu) {
				psp2chCursorSet( &DList[0]->menuPos, DList[0]->menuCount );
			} else {
				psp2chCursorSet( &DList[0]->pos, DList[0]->count );
			}
			if (DList[0]->complete && s2ch.pad.Buttons != s2ch.oldPad.Buttons)
			{
				s2ch.oldPad = s2ch.pad;

				if (s2ch.pad.Buttons & (PSP_CTRL_CIRCLE | PSP_CTRL_RIGHT))	//  []
				{
					if (DList[0]->count!=0 && DList[0]->file) {
						strcpy( file, path );
						strcat( file, "/" );
						strcat( file, DList[0]->file[DList[0]->pos].name2 );
						if (DList[0]->file[DList[0]->pos].type == 1)
						{
							if (DList[2]->file) {
								deleteDirList(&DList[2]);
							}
							FileList[2] = FileList[1];			// fBNgXgꎞޔ
							FileList[1] = FileList[0];			// fBNgXgꎞޔ
							strcpy(path, file);
							if (GetDir(path,&DList[0],1)) {
								break;
							}
							mode = 2;							// fBNgړJ(̃fBNg)
						}
						else									// t@CʂƂ̓
						{
							ret = checkExt(file);
							if (ret < 30) {						// t@CȂ
								if (ret < 10){					// 摜t@CȂ
									ListDraw( DList, 1 );
								}
								doFile( path, file, DList[0] );
								mode = 1;
							}
						}
					}
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_LEFT)		// []
				{
					p = strrchr( path, '/' );
					if (p) {									// ݈ʒu[gȊȌꍇ
						if (DList[2]->file) {
							deleteDirList(&DList[2]);
						}
						FileList[2] = FileList[1];				// fBNgXgꎞޔ
						FileList[1] = FileList[0];				// fBNgXgꎞޔ
						strcpy( DList[0]->dirName, p+1 );		// ܂ŋtH_ۑ
						*p = '\0';								// Ԍɂ'/'̈ʒuȌ폜
						if (GetDir(path,&DList[0],1)) {			// fBNgꗗ̎擾
							break;
						}
						strcpy( buf, path );
						p = strrchr( buf, '/' );
						if (p) {
							strcpy( DList[3]->dirName, p+1 );
							*p = '\0';
							GetDir( buf, &DList[3], 0 );
						} else {
							deleteDirList(&DList[3]);
						}
						mode = 3;								// fBNgړJ(ÕfBNg)
					}
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_CROSS)		// ~
				{
					ListDraw( DList, 1 );
					sceGuSync(GU_SYNC_FINISH, GU_SYNC_WHAT_DONE);
					flipScreen(0);
					if (MessageDialogYesNo(FV_MESSAGE_END) == PSP_UTILITY_MSGDIALOG_RESULT_YES){
						break;
					}
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_TRIANGLE)	// 
				{
					
				}

				else if (s2ch.pad.Buttons & PSP_CTRL_SQUARE)	// 
				{
					psp2chAudioStop();
					strcpy(file, path);
				}
			}
		}
		ListDraw( DList, mode );
		sceDisplayWaitVblankStart();
		flipScreen(0);
	}

	gGetThumbEnd = -1;
	sceKernelWaitThreadEnd( gThumbId, NULL );
	for (i=0; i<4; i++) {
		deleteDirList(&DList[i]);
	}
endFunc:
	sceKernelDeleteThread(gThumbId);
	sceKernelDeleteThread(gGetDirId[1]);
	sceKernelDeleteThread(gGetDirId[0]);
	return;
}

//==============================================================
// fBNg폜
//--------------------------------------------------------------
// w肳ꂽfBNgt@C܂߂č폜B
// ɂTufBNg폜܂B
//--------------------------------------------------------------

static void removeDir(char *path)
{
	SceIoDirent	dir;
	SceUID		fd;
	char		file[1024];

	if ((fd = sceIoDopen(path)) < 0) return;					// wfBNgJȂ̂ŏI
	memset(&dir, 0, sizeof(dir));								// ȂreadɎs
	while (sceIoDread(fd, &dir) > 0){
		if(strcmp(dir.d_name, ".") == 0) continue;
		if(strcmp(dir.d_name, "..") == 0) continue;
		strcpy( file, path );
		strcat( file, "/" );
		strcat( file, dir.d_name );
		if (dir.d_stat.st_attr & FIO_SO_IFDIR){					// fBNgHt@CH
			removeDir(file);									// fBNgiċAŃTufBNgj
		} else {
			sceIoRemove(file);									// t@C
		}
	}
	sceIoDclose(fd);
	sceIoRmdir(path);
}

/****************
t@C
****************/
#define FILE_CTRL_WIDTH (80)
#define FILE_CTRL_ITEM (6)
static int psp2chMenuFileCtrl(char* path, char* name, int status)
{
	static int mode = 0; // Rs[Cړ̃[h
	static char mpath[FILE_PATH], mname[FILE_PATH]; // ̏ꏊ
    const char* menuList[] = {"Rs[", "ړ", "y[Xg", "l[", "폜","ŊJ"};
    const char title1[] = "Vt@C͂Ă";
    const char *text = "Vt@C";
    SceUID fd, dst;
    char file[FILE_PATH], old[FILE_PATH], buf[BUF_LENGTH];
    int lineEnd = FILE_CTRL_ITEM, change = 1, size;
    int startX, startY, scrX, scrY,CHflag;

//	menu.count = FILE_CTRL_ITEM;
    startX = 350;
    startY = 100;
    scrX = FILE_CTRL_WIDTH;
//    scrY = FONTPITCH * lineEnd;
/*    menu.start = 0;
    menu.select = 0;
    if (menu.select >= FILE_CTRL_ITEM)
    {
        menu.start = menu.select - FILE_CTRL_ITEM + 1;
    }
    
*/    CHflag = 0;													// t@CzɕύXHi0:Noj
    while (!gExitRequest)
    {
        if(sceCtrlPeekBufferPositive(&s2ch.pad, 1))
        {
        	if (change)
			{
//	            psp2chDrawMenu((char**)menuList, menu, startX, startY, scrX, scrY);
			}
//            psp2chCursorSet(&menu);
            if (s2ch.pad.Buttons != s2ch.oldPad.Buttons)
            {
                s2ch.oldPad = s2ch.pad;
                if (s2ch.pad.Buttons & PSP_CTRL_CIRCLE)
                {
//                    switch (menu.select)
                    switch (0)
                    {
                	case 0:
						if (status) break;						// Ώۂ̓t@Cł͂Ȃ
                    	mode = 1;
                    	strcpy(mpath, path);
                    	strcpy(mname, name);
                    	break;
                    case 1:
						if (status) break;						// Ώۂ̓t@Cł͂Ȃ
                    	mode = 2;
                    	strcpy(mpath, path);
                    	strcpy(mname, name);
                        break;
                    case 2:
                    	if(!mode)
                    		break;
                    	sprintf(old, "%s/%s", mpath, mname);
                    	sprintf(file, "%s/%s", path, mname);
                    	if((fd = sceIoOpen(old, PSP_O_RDONLY, FILE_PARMISSION)) < 0)
                    	{
                    		psp2chNormalError(FILE_OPEN_ERR, old);
                    		break;
                    	}
                    	if((dst = sceIoOpen(file, PSP_O_WRONLY | PSP_O_CREAT, FILE_PARMISSION)) < 0)
                    	{
                    		psp2chNormalError(FILE_OPEN_ERR, file);
                    		sceIoClose(fd);
                    		break;
                    	}
                    	while((size = psp2chFileRead(fd, buf, sizeof(buf))) > 0)
                    	{
	                    	psp2chFileWrite(dst, buf, size);
	                    }
	                    sceIoClose(fd);
	                    sceIoClose(dst);
						CHflag = -1;							// t@CzɕύX
	                    if(mode == 2)
	                    {
	                    	sceIoRemove(old);
	                    	strcpy(mpath, "");
	                    	strcpy(mname, "");
	                    }
	                    mode = 0;
                        break;
                    case 3:
						if (s2ch.cfg.hbl){
							psp2chUTF82Sjis(buf, name);
						} else {
							strcpy(buf, name);
						}
						if(psp2chInputDialog((char*)title1, (char*)text, buf) == 0 && keyWords[0])
						{
							char	utf8[128];
							sprintf(old, "%s/%s", path, name);
							if (s2ch.cfg.hbl){
								psp2chSjis2UTF8(utf8, keyWords);
								sprintf(file, "%s/%s", path, utf8);
							} else {
								sprintf(file, "%s/%s", path, keyWords);
							}
							sceIoRename(old, file);
							CHflag = -1;						// t@CzɕύX
						}
                        break;
                    case 4:										// 폜
						sprintf(file, "%s/%s", path, name);
						if (s2ch.cfg.hbl){
							psp2chUTF82Sjis(buf, file);
						} else {
							strcpy(buf, file);
						}
						if (status){							// ΏۂfBNg
							if (MessageDialogYesNo("%s\n̓tH_ł\nt@CiTutH_܂ށj܂߂č폜܂낵ł", 
											buf) == PSP_UTILITY_MSGDIALOG_RESULT_YES){
								removeDir(file);
								CHflag = -1;					// t@CzɕύX
							}
						} else {								// Ώۂt@C
							if (MessageDialogYesNo("%s\n%s", buf, "̃t@C폜܂") == PSP_UTILITY_MSGDIALOG_RESULT_YES)
							{
								sceIoRemove(file);
								CHflag = -1;					// t@CzɕύX
							}
						}
                    	break;
                    case 5:										// ŊJ
						if (status) break;						// Ώۂ̓t@Cł͂Ȃ
						sprintf(file, "%s/%s", path, name);
						SMEMOfile( file );						// wt@CPSPŊJ
						break;
                    }
					change = 1;
                    break;
                }
                else if (s2ch.pad.Buttons & PSP_CTRL_CROSS)
                {
                    break;
                }
            }
			
			flipScreen(0);
        }
    }
    return CHflag;
}

