//==============================================================
// freeze viewer   (STPP.06)
//     for PSP CFW5.00 M33-6
// STEAR 2010-2011
//--------------------------------------------------------------
// freeze owataBGMt@C[x[Xɂ摜r[B
// intraFontx[X̃C^[tF[XɕύXB
//--------------------------------------------------------------

#include <pspdisplay.h>
#include <pspkernel.h>
#include <pspsdk.h>
#include <pspgu.h>
#include <psppower.h>
#include <psprtc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "FreezeViewer.h"
#include "psp2ch.h"
#include "fileList.h"
#include "psp2chAudio.h"
#include "intraFont.h"
#include "fvDraw.h"
#include "SMEMO/zenkaku.h"
#include "pspdialogs.h"

//------ 萔 -----

#define	VERSION		(0.64)

//------ s[hw -----

PSP_MODULE_INFO("freeze viewer", PSP_MODULE_USER, 0, 8);
PSP_MAIN_THREAD_ATTR(PSP_THREAD_ATTR_USER);
PSP_HEAP_SIZE_KB(-2048);

//----- O[oϐ -----

extern S_2CH	s2ch;
volatile int	gExitRequest = 0;								// PSP
DrawImg			*gScrBuf1, *gScrBuf2;							// wiޔ̈
DrawImg			*gScrMask;										// wip
DrawImg			*gIconImg[2];									// ACRp

void SMEMOinit(iniList *ini);									// PSP
void SMEMOend(void);											// PSP

void statusDraw(void);

//==============================================================
// Exit callback
//--------------------------------------------------------------

int exit_callback(int arg1, int arg2, void *common)
{
	gExitRequest = 1;											// PSP
	sceKernelExitGame();
	return 0;
}

//==============================================================
// Callback thread
//--------------------------------------------------------------

int power_callback(int unknown, int pwrflags, void *common)
{
	/* check for power switch and suspending as one is manual and the other automatic */
	if (pwrflags & PSP_POWER_CB_POWER_SWITCH || pwrflags & PSP_POWER_CB_SUSPENDING) {
		psp2chAudioStop();
	} else if (pwrflags & PSP_POWER_CB_RESUMING) {
	} else if (pwrflags & PSP_POWER_CB_RESUME_COMPLETE) {
	} else if (pwrflags & PSP_POWER_CB_STANDBY) {
	} else {
	}
	sceDisplayWaitVblankStart();

	return 0;
}

int CallbackThread(SceSize args, void *argp)
{
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);
	cbid = sceKernelCreateCallback("Power Callback", power_callback, NULL);
	scePowerRegisterCallback(0, cbid);
	sceKernelSleepThreadCB();

	return 0;
}

//==============================================================
// sleep thread
//--------------------------------------------------------------

int sleep_thread(SceSize args, void *argp)
{
	SceCtrlData	pad,pad2;
	int			count;

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	count = 0;
	pad2.Buttons = 0;
	pad2.Lx = pad2.Ly = 128;

	while (1){
		sceCtrlReadBufferPositive(&pad, 1);
		if (pad.Buttons & PSP_CTRL_HOLD || pad.Buttons != pad2.Buttons || abs(pad.Lx-pad2.Lx)>32 || abs(pad.Ly-pad2.Ly)>32) {
			count = 0;											// {^ĂJE^Zbg
		}
		pad2 = pad;
		if (s2ch.cfg.sleep) count++;							// TXyhԂ0ȂJEgȂ
		if (count > s2ch.cfg.sleep * 60 * 2) {					// w莞Ԍo߂TXyhV[PXN
			count = 0;
			scePowerTick(0);									// TXyh
			scePowerRequestSuspend();							// TXyhv
		}

		sceKernelDelayThread(500000);							// 0.5b҂
	}

    return 0;
}

//==============================================================
// Sets up the callback thread and returns its thread id
//--------------------------------------------------------------

int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0x0FA0, 0, 0);
	if (thid >= 0){
		sceKernelStartThread(thid, 0, 0);
	}
	thid = sceKernelCreateThread("sleep_thread", sleep_thread, 32, 0x800, 0, NULL);
	if(thid >= 0){
		sceKernelStartThread(thid, 0, 0);
	}
	return thid;
}


//==============================================================
// ݒXbh
//--------------------------------------------------------------

static int InitThread(SceSize args, void *argp)
{
	iniList	*ini = *((iniList**)argp);

	SMEMOinit(ini);									// PSP
	psp2chIniLoadConfig();
	ini->phase++;
	psp2chAudioInit(ini);
	ini->phase++;
	return 0;
}


//==============================================================
// ZbgAbv̉ʕ\
//--------------------------------------------------------------

static void iniDraw(iniList *ini)
{
	const char	*iniName[6] = {"intraFont[h", "PSPݒ[h", "monafont[h",
	                           "t@C[h", "freeze viewerݒ[h", "AV module[h"};
	static float	y[6] = {0,0,0,0,0,0};
	int		i;
	float	yv;

	fillScreenRect(s2ch.BakCor, 0, 0, 480, 272);
	for (i=0; i<6; i++) {
		yv = (i * 14 - y[i]) / 6;
		y[i] += yv;
		if (ini->phase>i) {
			mh_print( 5, y[i], iniName[i], 0xA0A0A0 );
			if (ini->msg[i][0]=='\0') {
				mh_print( 5+13*12, y[i], "OK", 0xFFC0C0 );
			} else {
				mh_print( 5+13*12, y[i], ini->msg[i], 0xC0C0FF );
			}
		} else if (ini->phase==i) {
			mh_print( 5, y[i], iniName[i], 0xFFFFFF );
		} else {
			mh_print( 5, y[i], iniName[i], 0xA0A0A0 );
		}
	}
}

//==============================================================
// main
//--------------------------------------------------------------

int main(int argc, char *argv[])
{
	SceIoStat	st;
	pspTime		time;
	u64			tick1, tick2, tick3;
	iniList		iniDat ,*ini;
	char	*ch, msg[256];
	int		i, thid;

	strcpy(s2ch.cwDir, argv[0]);
	ch = strrchr(s2ch.cwDir, '/');
	*ch = '\0';
	SetupCallbacks();
	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	initGraphics();
	flipScreen();

	gExitRequest = 0;
	gScrBuf1 = DrawImgCreate(480, 272);							// wiޔ̈m
	gScrBuf2 = DrawImgCreate(480, 272);							// wiޔ̈m
	gScrMask = DrawImgCreate(480, 16);							// wip
	gIconImg[0] = DrawImgCreate(64, 48);						// ACRp
	gIconImg[1] = DrawImgCreate(64, 38);						// ACRp

	if (gScrBuf1==NULL || gScrBuf2==NULL || gScrMask==NULL ||
	    gIconImg[0]==NULL || gIconImg[1]==NULL ) {
		MessageDialogText("Ɨpobt@̊mۂɎs܂\nI܂");
		goto END;
	}
	s2ch.BakCor = 0x00104010;

	//----- ef[^̃ZbgAbv -----

	for (i=0; i<6; i++) {
		iniDat.msg[i][0] = '\0';
	}
	thid = sceKernelCreateThread( "init_thread", (SceKernelThreadEntry)&InitThread, 0x30, 0x2000, 0, NULL );
	if (thid < 0) goto END;
	ini = &iniDat;
	ini->phase = 0;
	ini->error = 0;
	sceKernelStartThread( thid, sizeof(iniList**), (void*)&ini );
	while (!gExitRequest) {
		iniDraw(ini);
		if (sceKernelGetThreadExitStatus(thid) >= 0) break;
		sceDisplayWaitVblankStart();
		ScreenView();											// ʍXV
	}
	BoxFillImage( gIconImg[0], 0, 0 , 30  , 10   , 0xA000FFFF );
	BoxFillImage( gIconImg[0], 0, 10, 64  , 48-10, 0xA000FFFF );
	BoxFillImage( gIconImg[0], 2, 12, 64-4, 48-14, 0x5000FFFF );	// tH_ACR
	BoxFillImage( gIconImg[1], 0, 0 , 64  , 38   , 0xA0FFFFFF );
	BoxFillImage( gIconImg[1], 2, 2 , 64-4, 38-4 , 0x50FFFFFF );	// ̑t@CACR
	sceKernelDeleteThread(thid);
	iniDraw(ini);
	ScreenView();												// ʍXV
	if (iniDat.error < 0) {
		MessageDialogText("ZbgAbvŖ肪܂\n̂܂܂ł͑s鎖oȂߏI܂");
		goto END;
	}
	for (i=0; i<6; i++){
		if (strlen(iniDat.msg[i]) != 0) {
			MessageDialogText("ZbgAbvŖ肪܂̂܂ܑs܂");
			break;
		}
	}

	//----- C ----

	fillScreenRect(s2ch.BakCor, 0, 0, 480, 272);
	sprintf(msg, "freeze viewer ver%-3.2f", VERSION);
	guStart();
	if_print(5, 17, msg, 1.0f, 0xFFFFFF, 0x010101, 0.2f);
	if_print(5, 32, "By.STEAR 2010-2011", 0.7f, 0xFFFFFF, 0x010101, 0.2f);
	sceGuFinish();
	flipScreen(0);
	blitScreenToImage(0, 0, 480, 272, gScrBuf1, 0, 0);

	sceRtcGetCurrentClockLocalTime(&time);
	sceRtcGetTick( &time, &tick1 );
	if (sceIoGetstat(argv[0], &st) >= 0) {
		sceRtcGetTick( (pspTime*)&st.st_mtime, &tick2 );
		sceRtcTickAddDays( &tick3, &tick2, 5 );
		if (sceRtcCompareTick(&tick1,&tick3) < 0) {
			fileList( s2ch.cfg.imageDir );
		}
	}

	//----- I -----

	SMEMOend();													// PSP
END:
	DrawImgFree(gIconImg[1]);
	DrawImgFree(gIconImg[0]);
	DrawImgFree(gScrMask);
	DrawImgFree(gScrBuf2);
	DrawImgFree(gScrBuf1);
	psp2chAudioTerm();
	sceKernelExitGame();
	return 0;
}
