/*
* $Id: psp2ch.c 157 2008-09-16 23:13:56Z bird_may_nike $
*/

#include "FreezeViewer.h"
#include "psp2ch.h"
#include <psputility.h>
#include <psprtc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "pspdialogs.h"
#include "fileList.h"
#include "psp2chIni.h"
#include "charConv.h"
#include "psp2chAudio.h"
#include "fvDraw.h"
#include "smemo/strInput.h"
#include "smemo/sime.h"

S_2CH s2ch;
char keyWords[128];
const char searchWords[] = "searchHistory.dat";

// prototype
int psp2chInputKana(char* buf, unsigned int max);


/*****************************
X^[g
*****************************/
/*
static void psp2chStart(void)
{
	pgFillvram(FORM_INDEX + 3, 0, 0, SCR_WIDTH, SCR_HEIGHT, 2);
	pgSetDrawStart(0, 0, 0, 0);
	pgPrint("Freeze Owata+1 based Freeze Owata(by KMA) rev 100331", RED, WHITE, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH*2);
	pgPrint("Freeze Owata based owata browser(by toyo) rev 161", WHITE, WHITE, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("used libraries: Many thanks!!", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  libCat Copyright (c) 2008 SofiyaL", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  libjpeg@Copyright (c) 1991-1998, Thomas G. Lane.", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  zlib@Copyright (c) 1995-2004 Jean-loup Gailly and Mark Adler.", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  libpng@Copyright (c) 1998-2004 Glenn Randers-Pehrson.", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  libungif 4.1.4 Copyright (c) 1997  Eric S. Raymond", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  S 5.9.0 Copyright (c) 2002-2006  K.Kosako", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("  S 5.9.0 for PSP Copyright (c) 2007 NIPS", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH*2);
	pgPrint("PSP Ver1.09 By.STEAR 2009-2010", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH*2);
	pgPrint("START: ", GREEN, BLACK, SCR_WIDTH);
	pgSetDrawStart(50, -1, 0, 0);
	pgPrint("view category list", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("CIRCLE: ", GREEN, BLACK, SCR_WIDTH);
	pgSetDrawStart(50, -1, 0, 0);
	pgPrint("favorite thread list", WHITE, BLACK, SCR_WIDTH);
	pgSetDrawStart(0, -1, 0, LINE_PITCH);
	pgPrint("CROSS: ", GREEN, BLACK, SCR_WIDTH);
	pgSetDrawStart(50, -1, 0, 0);
	pgPrint("exit", WHITE, BLACK, SCR_WIDTH);
    if (s2ch.pad.Buttons != s2ch.oldPad.Buttons)
    {
        if(s2ch.pad.Buttons & PSP_CTRL_CROSS)
        {
//            if (psp2chOwata())
            {
                return;
            }
        }
        else if(s2ch.pad.Buttons & PSP_CTRL_START)
        {
            s2ch.sel = 2;
            return;
        }
        else if(s2ch.pad.Buttons & PSP_CTRL_CIRCLE)
        {
            s2ch.sel = 1;
            return;
        }
    }
    pgCopy(0, 0);
}
*/

//==============================================================
// J[\ړ`FbN
//--------------------------------------------------------------

void psp2chCursorSet(int *pos, int count)
{
	static int		keyStart = 0, keyRepeat = 0;
	static clock_t	keyTime = 0;
	int			padUp = 0, padDown = 0;

	if (s2ch.pad.Ly < 20) {
		padUp = 1;
	}
	else if (s2ch.pad.Ly > 235) {
		padDown = 1;
	}

	if (padUp) {
		(*pos)--;
	}
	else if (padDown) {
		(*pos)++;
	}

	if (s2ch.pad.Buttons != s2ch.oldPad.Buttons || keyRepeat) {
		if (s2ch.pad.Buttons != s2ch.oldPad.Buttons) {
			keyStart = 1;
		} else {
			keyStart = 0;
		}
		keyTime = sceKernelLibcClock();
		keyRepeat = 0;
		if (s2ch.pad.Buttons & PSP_CTRL_UP) {
			(*pos)--;
		} 
		else if (s2ch.pad.Buttons & PSP_CTRL_DOWN)
		{
			(*pos)++;
		}

	} else {
		if (keyStart) {
			if (sceKernelLibcClock() - keyTime > 300000) {
				keyRepeat = 1;
			}
		} else {
			if (sceKernelLibcClock() - keyTime > 10000) {
				keyRepeat = 1;
			}
		}
	}

	// ͈͊O̕␳
	if (*pos < 0) {
		*pos = 0;
	}
	else if (*pos >= count) {
		*pos = count - 1;
	}
}


/*****************************
OnScreenKeyboardŕ
title: OSK̉Eɕ\^Cg(SJIS)
text:͕ۑ|C^
num:͕̒
lines:͕̍s
OSK̓Ch(UCS)ŋAĂ̂SJISɕϊĂ܂B
*****************************/
void psp2chGets(char* title, char* text, int num, int lines)
{
    unsigned char* p;
    unsigned short string[128];
    unsigned short pretext[128], text_buf[128];
    int running = 0;
    char* buf = "l_(^o^)^";

    if (num > 128)
    {
        num = 128;
    }
    /* sjis => ucs */
    if (title && *title != '\0')
    {
        p = (unsigned char*)title;
    }
    else
    {
        p = (unsigned char*)buf;
    }
    psp2chSJIS2UCS( string, p, 127 );
    p = (unsigned char*)text;
    psp2chSJIS2UCS( pretext, p, 127 );
    
    SceUtilityOskData data;
    SceUtilityOskParams param;
    
    memset(&data, 0, sizeof(data));
    data.language = PSP_UTILITY_OSK_LANGUAGE_DEFAULT;
    data.unk_00 = 1;
    data.unk_04 = 0;
    data.language = PSP_UTILITY_OSK_LANGUAGE_DEFAULT;
    data.unk_12 = 0;
    data.inputtype = PSP_UTILITY_OSK_INPUTTYPE_ALL;
    data.lines = lines;
    data.unk_24 = 1;
    data.desc = string;
    data.intext = pretext;
    data.outtext = text_buf;
    data.outtextlength = num;
    data.outtextlimit = num;
    
    memset(&param, 0, sizeof(param));
    param.base.size = sizeof(param);
    sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_LANGUAGE, &param.base.language);
    sceUtilityGetSystemParamInt(PSP_SYSTEMPARAM_ID_INT_UNKNOWN, &param.base.buttonSwap);
    param.base.graphicsThread = 0x11;
    param.base.accessThread = 0x13;
    param.base.fontThread = 0x12;
    param.base.soundThread = 0x10;
    param.datacount = 1;
    param.data = &data;
	
	sceUtilityOskInitStart(&param);
	
	while(!running) {
//		pgGuRender();
		
		switch(sceUtilityOskGetStatus()) {
			case PSP_UTILITY_DIALOG_NONE :
				running = 1;
				break;
			case PSP_UTILITY_DIALOG_VISIBLE :
				sceUtilityOskUpdate(2);
				break;
			case PSP_UTILITY_DIALOG_QUIT :
				sceUtilityOskShutdownStart();
				break;
			default:
				break;
		}
		flipScreen(0);
	}

    /* ucs => sjis */
    psp2chUCS2SJIS((unsigned char*)text, text_buf, num);
}

//==============================================================
// Simple IMEɂ镶
//--------------------------------------------------------------
// ۂ̏PSP͂̕ōsĂ܂B
//--------------------------------------------------------------

static int psp2chLInput(char *title, char *pretext, int type)
{
	char		file[FILE_PATH];
	int			ret;
	strInpHis	**inphis;
	SceCtrlData	pad;

	sprintf(file, "%s/%s", s2ch.cwDir, searchWords);
	inphis = InputHisLoad( file );								// 擾
	keyWords[0] = '\0';
	if(pretext != NULL){
		strncpy(keyWords, pretext, sizeof(keyWords)-1);
	}

	initGraphics();												// PSPp惂[h
	flipScreen();												// ftHgł̓y[Wݒɕsŝ
	sceCtrlPeekBufferPositive(&pad, 1);
	SIMEgetchar(pad);											// Simple IMȄ͑΍
	ret = InputName(title, 50, type, keyWords, keyWords, inphis);
	if (!ret){													// ̏ꍇ͗Ɍo^
		InputHisAdd(inphis, keyWords);
		InputHisSave(file, inphis);
	}
	pad.Buttons = 0;
	SIMEgetchar(pad);											// Simple IMENɂȂL[s[gȂ悤
	InputHisFree(inphis);										// 폜
	sceCtrlPeekBufferPositive(&s2ch.pad, 1);
	s2ch.oldPad = s2ch.pad;										// ̌̃L[͎̃L[s[g΍

	return ret;
}

/****************
̓_CAO\
text1: _CAOɕ\^Cg
text2: OSKɕ\^Cg
߂l 0=, -1=
keyWords[]ɕ񂪕Ԃ
*****************/
int psp2chInputDialog(char *text1, char *text2, char *pretext)
{
	if (s2ch.cfg.inputType == 1){
		return psp2chLInput( text1, pretext, 1 );				// OSKŃC
	}
	return psp2chLInput( text1, pretext, 0 );					// Simple IMEŃC
}


int psp2chFileRead(SceUID fd, void *data, SceSize size)
{
	SceInt64 ret;
	
	ret = sceIoRead(fd, data, size);
	return ret;
}

int psp2chFileWrite(SceUID fd, const void *data, SceSize size)
{
	SceInt64 ret;
	
	ret = sceIoWrite(fd, data, size);
	if (ret != size)
		MessageDialogText("file write failed");
	return ret;
}

