//==============================================================
// PSPVXe_CAO֘A
//--------------------------------------------------------------

#ifndef __PSP_DIALOGS_H__
#define __PSP_DIALGOS_H__

#include <pspkernel.h>
#include <pspdisplay.h>
#include <string.h>
#include <psputility.h>
#include <psputility_osk.h>
#include <pspgu.h>

/*
  Autoset language according to your psp system
  see psputility_sysparam.h for language codes
*/
#define DIALOG_LANGUAGE_AUTO			(100)

extern void* framebuffer;

typedef struct
{
	char message[512];
	int options;
	pspUtilityMsgDialogPressed buttonPressed;
	int result;
}MESSAGE_HELPER;

/*
  Show a message dialog

  msg - Message to show
  language - set the language to display the message box in
  pass DIALOG_LANGUAGE_AUTO or see psputility_sysparam.h
*/
void pspShowMessageDialog(MESSAGE_HELPER *mh, u8 language);

/*
  Display a error code

  error - error to display, see pspkerror.h
  language - set the language to display the message box in
  pass DIALOG_LANGUAGE_AUTO or see psputility_sysparam.h
*/
void pspShowErrorDialog(const int error, u8 language);

//==============================================================
// bZ[W_CAŐNiYes/Noj
//--------------------------------------------------------------
// msg:\郁bZ[WiVtgJIS asciizj
// ߂l 0:UNKNOWN1
//        1:YES
//        2:NO
//        3:BACK
//--------------------------------------------------------------

int MessageDialogYesNo(char *fmt, ...);

//==============================================================
// bZ[W_CAŐNiOKj
//--------------------------------------------------------------
// msg:\郁bZ[WiVtgJIS asciizj
// ߂l 0:UNKNOWN1
//        1:YES
//        2:NO
//        3:BACK
//--------------------------------------------------------------

int MessageDialogText(char *fmt, ...);

#endif

